VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Die aktuelle Internetzeit auslesen II"
   ClientHeight    =   1380
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5400
   LinkTopic       =   "Form1"
   ScaleHeight     =   1380
   ScaleWidth      =   5400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSyncWithInetTime 
      Caption         =   "mit der Internetzeit &synchronisieren"
      Height          =   375
      Left            =   2280
      TabIndex        =   7
      Top             =   480
      Width           =   3075
   End
   Begin VB.CommandButton cmdGetINetTime 
      Caption         =   "Internetzeit &holen"
      Height          =   375
      Left            =   2280
      TabIndex        =   0
      Top             =   60
      Width           =   3075
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   60
      TabIndex        =   8
      Top             =   930
      Width           =   5295
   End
   Begin VB.Label lblSystem 
      Height          =   225
      Left            =   630
      TabIndex        =   6
      Top             =   600
      Width           =   1575
   End
   Begin VB.Label lblLocal 
      Height          =   225
      Left            =   630
      TabIndex        =   5
      Top             =   330
      Width           =   1575
   End
   Begin VB.Label lblGMT 
      Height          =   225
      Left            =   630
      TabIndex        =   4
      Top             =   60
      Width           =   1575
   End
   Begin VB.Label lblInf 
      Caption         =   "Sytem:"
      Height          =   225
      Index           =   2
      Left            =   60
      TabIndex        =   3
      Top             =   600
      Width           =   525
   End
   Begin VB.Label lblInf 
      Caption         =   "Local:"
      Height          =   225
      Index           =   1
      Left            =   60
      TabIndex        =   2
      Top             =   330
      Width           =   525
   End
   Begin VB.Label lblInf 
      Caption         =   "GMT:"
      Height          =   225
      Index           =   0
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   525
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Dadurch das die Internetzeit im RFC1123 Format vorliegt, kann hier nur
' eine sekundengenaue Synchronisation mit der Systemzeit vorgenommen
' werden bzw. die Internetzeit kann nur sekundengenau ermittelt werden.
' Millisekundengenaue synchronisation ist mit diesem Beispiel nicht mglich.

' Host, von dem die Zeitabfrage erfolgen soll.
' Praktisch kann hier jede verfgbare Internetadresse angegeben werden.
Private Const InetHost As String = "www.activevb.de"

Private Sub cmdGetINetTime_Click()

    Dim strINetTime As String
    Dim strLocalTime As String
    Dim strGmtTime As String
    Dim lngDiffSec As Long
    
    ' Statustext
    lblStatus.ForeColor = vbBlue
    lblStatus.Caption = "Internetzeit holen"
    
    DoEvents
    
    ' Internetzeit im RFC1123 Format vom Host ermitteln
    strINetTime = GetINetTime(InetHost)
    
    ' konnte eine Zeitangabe ausgelesen werden
    If Len(strINetTime) > 0 Then
    
        ' RFC1123 Format in das Date Format konvertieren
        strGmtTime = INetTimeToSystemTime(strINetTime)
        
        ' RFC1123 Format in das Date Format (Lokal) konvertieren
        strLocalTime = INetTimeToLocalTime(strINetTime)
        
        ' Differenz in Sekunden zwischen Lokaler- und Systemzeit
        lngDiffSec = CLng(DateDiff("s", CDate(strLocalTime), Now))
        
        ' Ausgabe der Zeiten
        lblGMT.Caption = strGmtTime
        lblLocal.Caption = strLocalTime
        lblSystem.Caption = Now
        
        ' Statustext
        lblStatus.ForeColor = vbBlack
        
        lblStatus.Caption = "Die Differenz zu Ihrer Systemzeit betrgt " & _
            "ca. " & CStr(Abs(lngDiffSec)) & " Sekunde(n)."
            
    Else
    
        ' wenn keine Zeitangabe ermittelt werden konnte
        ' Statustext
        lblStatus.ForeColor = vbRed
        
        lblStatus.Caption = "Die Internetzeit konnte nicht ermittelt " & _
            "werden bzw. " & vbNewLine & " die Internetadresse '" & InetHost _
            & "' war nicht erreichbar."
            
    End If
    
End Sub

Private Sub cmdSyncWithInetTime_Click()

    Dim strINetTime As String
    Dim strLocalTime As String
    Dim strGmtTime As String
    
    ' Statustext
    lblStatus.ForeColor = vbBlue
    lblStatus.Caption = "Internetzeit holen"
    
    DoEvents
    
    ' Internetzeit im RFC1123 Format vom Host ermitteln
    strINetTime = GetINetTime(InetHost)
    
    ' konnte eine Zeitangabe ausgelesen werden
    If Len(strINetTime) > 0 Then
    
        ' RFC1123 Format in das Date Format konvertieren
        strGmtTime = INetTimeToSystemTime(strINetTime)
        
        ' RFC1123 Format in das Date Format (Lokal) konvertieren
        strLocalTime = INetTimeToLocalTime(strINetTime)
        
        ' Systemzeit setzen. Hier muss die GMT-Zeit verwendet
        ' werden. Intern wird dann automatisch die Lokale-Zeit
        ' verwendet.
        If SyncSystemTime(CDate(strGmtTime)) Then
        
            ' Statustext wenn erfolgreich
            lblStatus.ForeColor = vbBlack
            lblStatus.Caption = "Die Synchronisierung war erfolgreich."
            
        Else
        
            ' Statustext wenn nicht erfolgreich
            lblStatus.ForeColor = vbRed
            lblStatus.Caption = "Die Synchronisierung war nicht erfolgreich."
            
        End If
        
        ' Ausgabe der Zeiten
        lblGMT.Caption = strGmtTime
        lblLocal.Caption = strLocalTime
        lblSystem.Caption = Now
        
    Else
    
        ' wenn keine Zeitangabe ermittelt werden konnte
        ' Statustext
        lblStatus.ForeColor = vbRed
        
        lblStatus.Caption = "Die Internetzeit konnte nicht ermittelt " & _
            "werden bzw. " & vbNewLine & " die Internetadresse '" & InetHost _
            & "' war nicht erreichbar."
            
    End If
    
End Sub
